/*
  libSDL2pp - C++11 bindings/wrapper for SDL2
  Copyright (C) 2014 Dmitry Marakasov <amdmi3@amdmi3.ru>

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
*/

#ifndef SDL2PP_AUDIOSPEC_HH
#define SDL2PP_AUDIOSPEC_HH

#include <SDL2/SDL_audio.h>

namespace SDL2pp {

class AudioSpec : public SDL_AudioSpec {

public:
	AudioSpec();
	AudioSpec(int freq, SDL_AudioFormat format, Uint8 channels, Uint16 samples);
	~AudioSpec();

	AudioSpec(AudioSpec&& other);
	AudioSpec& operator=(AudioSpec&& other);
	AudioSpec(const AudioSpec& other) = delete;
	AudioSpec& operator=(const AudioSpec& other) = delete;

	void MergeChanges(const SDL_AudioSpec& obtained);
	const SDL_AudioSpec* Get() const;

	bool IsSameFormat(const AudioSpec& other) const;
};

}

#endif
